Index: EcnlProtoTool/trunk/webapp/webmrbc/Arduino/I2cBlock.cs
===================================================================
--- EcnlProtoTool/trunk/webapp/webmrbc/Arduino/I2cBlock.cs	(revision 270)
+++ EcnlProtoTool/trunk/webapp/webmrbc/Arduino/I2cBlock.cs	(revision 273)
@@ -18,5 +18,5 @@
 			this.appendDummyInput()
 				.appendField("I2Cの初期化")
-				.appendField(GrPeach.I2CPorts(), "I2C_PORT_NO");
+				.appendField(App.TargetBoard.I2CPorts(), "I2C_PORT_NO");
 			this.setInputsInline(true);
 			this.setPreviousStatement(true, null);
@@ -40,5 +40,5 @@
 			this.appendDummyInput()
 				.appendField("I2Cへの書き込み")
-				.appendField(GrPeach.I2CPorts(), "I2C_PORT_NO");
+				.appendField(App.TargetBoard.I2CPorts(), "I2C_PORT_NO");
 			this.appendValueInput("DEVICEID")
 				.setCheck("Number")
@@ -72,5 +72,5 @@
 			this.appendDummyInput()
 				.appendField("I2Cからの読み込み")
-				.appendField(GrPeach.I2CPorts(), "I2C_PORT_NO");
+				.appendField(App.TargetBoard.I2CPorts(), "I2C_PORT_NO");
 			this.appendValueInput("DEVICEID")
 				.setCheck("Number")
@@ -103,5 +103,5 @@
 			this.appendDummyInput()
 				.appendField("I2Cの送信開始準備")
-				.appendField(GrPeach.I2CPorts(), "I2C_PORT_NO");
+				.appendField(App.TargetBoard.I2CPorts(), "I2C_PORT_NO");
 			this.appendValueInput("DEVICEID")
 				.setCheck("Number")
@@ -129,5 +129,5 @@
 			this.appendDummyInput()
 				.appendField("I2Cの送信バッファの末尾に数値を追加する")
-				.appendField(GrPeach.I2CPorts(), "I2C_PORT_NO");
+				.appendField(App.TargetBoard.I2CPorts(), "I2C_PORT_NO");
 			this.appendValueInput("DATA")
 				.setCheck("Number")
@@ -154,5 +154,5 @@
 			this.appendDummyInput()
 				.appendField("I2Cの送信シーケンスを発行する")
-				.appendField(GrPeach.I2CPorts(), "I2C_PORT_NO");
+				.appendField(App.TargetBoard.I2CPorts(), "I2C_PORT_NO");
 			this.appendDummyInput()
 				.appendField("ストップコンディション発生")
@@ -179,5 +179,5 @@
 			this.appendDummyInput()
 				.appendField("I2Cへ受信シーケンスを発行する")
-				.appendField(GrPeach.I2CPorts(), "I2C_PORT_NO");
+				.appendField(App.TargetBoard.I2CPorts(), "I2C_PORT_NO");
 			this.appendValueInput("ADDRESS")
 				.setCheck("Number")
@@ -206,5 +206,5 @@
 			this.appendDummyInput()
 				.appendField("I2Cへ受信シーケンスを発行しデータを読み出す")
-				.appendField(GrPeach.I2CPorts(), "I2C_PORT_NO");
+				.appendField(App.TargetBoard.I2CPorts(), "I2C_PORT_NO");
 			this.setInputsInline(true);
 			this.setOutput(true, "Number");
@@ -228,5 +228,5 @@
 			this.appendDummyInput()
 				.appendField("I2Cの受信バッファ内にあるデータ数を調べる")
-				.appendField(GrPeach.I2CPorts(), "I2C_PORT_NO");
+				.appendField(App.TargetBoard.I2CPorts(), "I2C_PORT_NO");
 			this.setInputsInline(true);
 			this.setOutput(true, "Number");
@@ -250,5 +250,5 @@
 			this.appendDummyInput()
 				.appendField("I2Cの周波数を変更する")
-				.appendField(GrPeach.I2CPorts(), "I2C_PORT_NO");
+				.appendField(App.TargetBoard.I2CPorts(), "I2C_PORT_NO");
 			this.appendValueInput("FREQUENCY")
 				.setCheck("Number")
@@ -269,8 +269,8 @@
 			var dropdown_i2c_port_no = block.getFieldValue("I2C_PORT_NO");
 			// $i2c0 = I2c.new(0)
-			var a = new gvar_node(this, intern(GrPeach.I2CPortNameToVariable(dropdown_i2c_port_no)));
+			var a = new gvar_node(this, intern(App.TargetBoard.I2CPortNameToVariable(dropdown_i2c_port_no)));
 			var c = new const_node(this, intern("I2c"));
 			var p = new node[] {
-				new int_node(this, GrPeach.I2CPortNameToNum(dropdown_i2c_port_no))
+				new int_node(this, App.TargetBoard.I2CPortNameToNum(dropdown_i2c_port_no))
 			};
 			return new asgn_node(this, a, new call_node(this, c, intern("new"), p, null));
@@ -284,5 +284,5 @@
 			var value_data = valueToCode(block, "DATA");
 			// $i2c0.write(0, 0x00, 0x00)
-			var a = new gvar_node(this, intern(GrPeach.I2CPortNameToVariable(dropdown_i2c_port_no)));
+			var a = new gvar_node(this, intern(App.TargetBoard.I2CPortNameToVariable(dropdown_i2c_port_no)));
 			var p = new node[] {
 				value_deviceid,
@@ -300,5 +300,5 @@
 			var value_address_h = valueToCode(block, "ADDRESS_H");
 			// $i2c0.read(0, 0x00, 0x00)
-			var a = new gvar_node(this, intern(GrPeach.I2CPortNameToVariable(dropdown_i2c_port_no)));
+			var a = new gvar_node(this, intern(App.TargetBoard.I2CPortNameToVariable(dropdown_i2c_port_no)));
 			var p = new node[] {
 				value_deviceid,
@@ -316,5 +316,5 @@
 			var value_deviceid = valueToCode(block, "DEVICEID");
 			// $i2c0.begin(0)
-			var a = new gvar_node(this, intern(GrPeach.I2CPortNameToVariable(dropdown_i2c_port_no)));
+			var a = new gvar_node(this, intern(App.TargetBoard.I2CPortNameToVariable(dropdown_i2c_port_no)));
 			var p = new node[] {
 				value_deviceid,
@@ -328,5 +328,5 @@
 			var value_data = valueToCode(block, "DATA");
 			// $i2c0.lwrite(0x00)
-			var a = new gvar_node(this, intern(GrPeach.I2CPortNameToVariable(dropdown_i2c_port_no)));
+			var a = new gvar_node(this, intern(App.TargetBoard.I2CPortNameToVariable(dropdown_i2c_port_no)));
 			var p = new node[0];
 			if (value_data != null)
@@ -340,5 +340,5 @@
 			var checkbox_stop = block.getFieldValue("STOP");
 			// $i2c0.lwrite(0x00)
-			var a = new gvar_node(this, intern(GrPeach.I2CPortNameToVariable(dropdown_i2c_port_no)));
+			var a = new gvar_node(this, intern(App.TargetBoard.I2CPortNameToVariable(dropdown_i2c_port_no)));
 			var p = new node[0];
 			if (checkbox_stop != null)
@@ -353,5 +353,5 @@
 			var value_count = valueToCode(block, "COUNT");
 			// $i2c0.request(0x00, 1)
-			var a = new gvar_node(this, intern(GrPeach.I2CPortNameToVariable(dropdown_i2c_port_no)));
+			var a = new gvar_node(this, intern(App.TargetBoard.I2CPortNameToVariable(dropdown_i2c_port_no)));
 			var p = new node[] {
 				value_address,
@@ -365,5 +365,5 @@
 			var dropdown_i2c_port_no = block.getFieldValue("I2C_PORT_NO");
 			// $i2c0.lread()
-			var a = new gvar_node(this, intern(GrPeach.I2CPortNameToVariable(dropdown_i2c_port_no)));
+			var a = new gvar_node(this, intern(App.TargetBoard.I2CPortNameToVariable(dropdown_i2c_port_no)));
 			var p = new node[0];
 			return new call_node(this, a, intern("lread"), p, null);
@@ -374,5 +374,5 @@
 			var dropdown_i2c_port_no = block.getFieldValue("I2C_PORT_NO");
 			// $i2c0.available()
-			var a = new gvar_node(this, intern(GrPeach.I2CPortNameToVariable(dropdown_i2c_port_no)));
+			var a = new gvar_node(this, intern(App.TargetBoard.I2CPortNameToVariable(dropdown_i2c_port_no)));
 			var p = new node[0];
 			return new call_node(this, a, intern("available"), p, null);
@@ -384,5 +384,5 @@
 			var value_frequency = valueToCode(block, "FREQUENCY");
 			// $i2c0.frequency(0)
-			var a = new gvar_node(this, intern(GrPeach.I2CPortNameToVariable(dropdown_i2c_port_no)));
+			var a = new gvar_node(this, intern(App.TargetBoard.I2CPortNameToVariable(dropdown_i2c_port_no)));
 			var p = new node[] {
 				value_frequency