Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/udp_usrreq.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/udp_usrreq.c	(revision 270)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/udp_usrreq.c	(revision 279)
@@ -485,5 +485,5 @@
 		return E_NOEXS;
 
-	return E_PAR;
+	return E_OK/*E_PAR*/;
 	}
 
@@ -518,5 +518,5 @@
 		return E_NOEXS;
 
-	return E_PAR;
+	return E_OK/*E_PAR*/;
 	}
 
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/tcpip_api.def
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/tcpip_api.def	(revision 270)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/tcpip_api.def	(revision 279)
@@ -5,8 +5,8 @@
 UDP_CRE_CEP  #udp4_cepid* { .udp4_cepatr { &ipv4addr &portno } &callback }
 UDP6_CRE_CEP #udp6_cepid* { .udp6_cepatr { &ipv6addr &portno } &callback }
-VRID_TCP_REP  #vrid_tcp4_repid*
-VRID_TCP_CEP  #vrid_tcp4_cepid*
+VRID_TCP4_REP  #vrid_tcp4_repid*
+VRID_TCP4_CEP  #vrid_tcp4_cepid*
 VRID_TCP6_REP #vrid_tcp6_repid*
 VRID_TCP6_CEP #vrid_tcp6_cepid*
-VRID_UDP_CEP  #vrid_udp4_cepid*
+VRID_UDP4_CEP  #vrid_udp4_cepid*
 VRID_UDP6_CEP #vrid_udp6_cepid*
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/tinet.trb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/tinet.trb	(revision 270)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/tinet.trb	(revision 279)
@@ -78,21 +78,21 @@
 	$tinetCfgH.add("#define #{params[:udp6_cepid]}	#{params[:udp6_cepid].val}")
 end
-$cfgData[:VRID_TCP_REP].each do |key, params|
-	$tinetCfgH.add("#define #{params[:tcp4_repid]}	#{params[:tcp4_repid].val + $cfgData[:TCP_CRE_REP].size}")
-end
-$cfgData[:VRID_TCP_CEP].each do |key, params|
-	$tinetCfgH.add("#define #{params[:tcp4_cepid]}	#{params[:tcp4_cepid].val + $cfgData[:TCP_CRE_CEP].size}")
+$cfgData[:VRID_TCP4_REP].each do |key, params|
+	$tinetCfgH.add("#define #{params[:vrid_tcp4_repid]}	#{params[:vrid_tcp4_repid].val + $cfgData[:TCP_CRE_REP].size}")
+end
+$cfgData[:VRID_TCP4_CEP].each do |key, params|
+	$tinetCfgH.add("#define #{params[:vrid_tcp4_cepid]}	#{params[:vrid_tcp4_cepid].val + $cfgData[:TCP_CRE_CEP].size}")
 end
 $cfgData[:VRID_TCP6_REP].each do |key, params|
-	$tinetCfgH.add("#define #{params[:tcp6_repid]}	#{params[:tcp6_repid].val + $cfgData[:TCP6_CRE_REP].size}")
+	$tinetCfgH.add("#define #{params[:vrid_tcp6_repid]}	#{params[:vrid_tcp6_repid].val + $cfgData[:TCP6_CRE_REP].size}")
 end
 $cfgData[:VRID_TCP6_CEP].each do |key, params|
-	$tinetCfgH.add("#define #{params[:tcp6_cepid]}	#{params[:tcp6_cepid].val + $cfgData[:TCP6_CRE_CEP].size}")
-end
-$cfgData[:VRID_UDP_CEP].each do |key, params|
-	$tinetCfgH.add("#define #{params[:udp4_cepid]}	#{params[:udp4_cepid].val + $cfgData[:UDP_CRE_CEP].size}")
+	$tinetCfgH.add("#define #{params[:vrid_tcp6_cepid]}	#{params[:vrid_tcp6_cepid].val + $cfgData[:TCP6_CRE_CEP].size}")
+end
+$cfgData[:VRID_UDP4_CEP].each do |key, params|
+	$tinetCfgH.add("#define #{params[:vrid_udp4_cepid]}	#{params[:vrid_udp4_cepid].val + $cfgData[:UDP_CRE_CEP].size}")
 end
 $cfgData[:VRID_UDP6_CEP].each do |key, params|
-	$tinetCfgH.add("#define #{params[:udp6_cepid]}	#{params[:udp6_cepid].val + $cfgData[:UDP6_CRE_CEP].size}")
+	$tinetCfgH.add("#define #{params[:vrid_udp6_cepid]}	#{params[:vrid_udp6_cepid].val + $cfgData[:UDP6_CRE_CEP].size}")
 end
 $tinetCfgH.add()
@@ -144,7 +144,7 @@
 
 #	// TCP (IPv4) åä»å£
-if $cfgData[:TCP_CRE_REP].size > 0 || $cfgData[:VRID_TCP_REP].size > 0
-	$tinetCfgC.add()
-	$tinetCfgC.add("#define TNUM_TCP_REPID	#{$cfgData[:TCP_CRE_REP].size + $cfgData[:VRID_TCP_REP].size}")
+if $cfgData[:TCP_CRE_REP].size > 0 || $cfgData[:VRID_TCP4_REP].size > 0
+	$tinetCfgC.add()
+	$tinetCfgC.add("#define TNUM_TCP_REPID	#{$cfgData[:TCP_CRE_REP].size + $cfgData[:VRID_TCP4_REP].size}")
 	$tinetCfgC.add()
 	$tinetCfgC.add("const ID tmax_tcp_repid = (TMIN_TCP_REPID + TNUM_TCP_REPID - 1);")
@@ -161,5 +161,5 @@
 			$tinetCfgC.add("\t\t},")
 	end
-	$cfgData[:VRID_TCP_REP].each do |key, params|
+	$cfgData[:VRID_TCP4_REP].each do |key, params|
 		$tinetCfgC.add("\t{")
 			$tinetCfgC.add("\t\t0,")
@@ -167,5 +167,5 @@
 	$tinetCfgC.add("#if defined(TCP_CFG_EXTENTIONS)")
 			$tinetCfgC.add("\t\tTCP_REP_FLG_DYNAMIC,")
-			$tinetCfgC.add("\t\tSEM_TCP_REP_LOCK#{params[:tcp4_repid].val + $cfgData[:TCP_CRE_REP].size},")
+			$tinetCfgC.add("\t\tSEM_TCP_REP_LOCK#{params[:vrid_tcp4_repid].val + $cfgData[:TCP_CRE_REP].size},")
 	$tinetCfgC.add("#endif")
 			$tinetCfgC.add("\t\t},")
@@ -198,5 +198,5 @@
 	$tinetCfgC.add("#if defined(TCP_CFG_EXTENTIONS)")
 			$tinetCfgC.add("\t\tTCP_REP_FLG_DYNAMIC,")
-			$tinetCfgC.add("\t\tSEM_TCP_REP_LOCK#{params[:tcp6_repid].val + $cfgData[:TCP6_CRE_REP].size},")
+			$tinetCfgC.add("\t\tSEM_TCP_REP_LOCK#{params[:vrid_tcp6_repid].val + $cfgData[:TCP6_CRE_REP].size},")
 	$tinetCfgC.add("#endif")
 			$tinetCfgC.add("\t\t},")
@@ -206,7 +206,7 @@
 
 #	// TCP (IPv4) éä¿¡ç«¯ç¹
-if $cfgData[:TCP_CRE_CEP].size > 0 || $cfgData[:VRID_TCP_CEP].size > 0
-	$tinetCfgC.add()
-	$tinetCfgC.add("#define TNUM_TCP_CEPID	#{$cfgData[:TCP_CRE_CEP].size + $cfgData[:VRID_TCP_CEP].size}")
+if $cfgData[:TCP_CRE_CEP].size > 0 || $cfgData[:VRID_TCP4_CEP].size > 0
+	$tinetCfgC.add()
+	$tinetCfgC.add("#define TNUM_TCP_CEPID	#{$cfgData[:TCP_CRE_CEP].size + $cfgData[:VRID_TCP4_CEP].size}")
 	$tinetCfgC.add()
 	$tinetCfgC.add("const ID tmax_tcp_cepid = (TMIN_TCP_CEPID + TNUM_TCP_CEPID - 1);")
@@ -228,5 +228,5 @@
 			$tinetCfgC.add("\t\t},")
 	end
-	$cfgData[:VRID_TCP_CEP].each do |key, params|
+	$cfgData[:VRID_TCP4_CEP].each do |key, params|
 		$tinetCfgC.add("\t{")
 			$tinetCfgC.add("\t\t0,")
@@ -237,8 +237,8 @@
 			$tinetCfgC.add("\t\t(t_tcp_callback)(FP)NULL,")
 			$tinetCfgC.add("\t\tTCP_CEP_FLG_DYNAMIC,")
-			$tinetCfgC.add("\t\tSEM_TCP_CEP_LOCK#{params[:tcp4_cepid].val + $cfgData[:TCP_CRE_CEP].size},")
-			$tinetCfgC.add("\t\tFLG_TCP_CEP_EST#{params[:tcp4_cepid].val + $cfgData[:TCP_CRE_CEP].size},")
-			$tinetCfgC.add("\t\tFLG_TCP_CEP_SND#{params[:tcp4_cepid].val + $cfgData[:TCP_CRE_CEP].size},")
-			$tinetCfgC.add("\t\tFLG_TCP_CEP_RCV#{params[:tcp4_cepid].val + $cfgData[:TCP_CRE_CEP].size},")
+			$tinetCfgC.add("\t\tSEM_TCP_CEP_LOCK#{params[:vrid_tcp4_cepid].val + $cfgData[:TCP_CRE_CEP].size},")
+			$tinetCfgC.add("\t\tFLG_TCP_CEP_EST#{params[:vrid_tcp4_cepid].val + $cfgData[:TCP_CRE_CEP].size},")
+			$tinetCfgC.add("\t\tFLG_TCP_CEP_SND#{params[:vrid_tcp4_cepid].val + $cfgData[:TCP_CRE_CEP].size},")
+			$tinetCfgC.add("\t\tFLG_TCP_CEP_RCV#{params[:vrid_tcp4_cepid].val + $cfgData[:TCP_CRE_CEP].size},")
 			$tinetCfgC.add("\t\t},")
 	end
@@ -278,8 +278,8 @@
 			$tinetCfgC.add("\t\t(t_tcp_callback)(FP)NULL,")
 			$tinetCfgC.add("\t\tTCP_CEP_FLG_DYNAMIC,")
-			$tinetCfgC.add("\t\tSEM_TCP_CEP_LOCK#{params[:tcp6_cepid].val + $cfgData[:TCP6_CRE_CEP].size},")
-			$tinetCfgC.add("\t\tFLG_TCP_CEP_EST#{params[:tcp6_cepid].val + $cfgData[:TCP6_CRE_CEP].size},")
-			$tinetCfgC.add("\t\tFLG_TCP_CEP_SND#{params[:tcp6_cepid].val + $cfgData[:TCP6_CRE_CEP].size},")
-			$tinetCfgC.add("\t\tFLG_TCP_CEP_RCV#{params[:tcp6_cepid].val + $cfgData[:TCP6_CRE_CEP].size},")
+			$tinetCfgC.add("\t\tSEM_TCP_CEP_LOCK#{params[:vrid_tcp6_cepid].val + $cfgData[:TCP6_CRE_CEP].size},")
+			$tinetCfgC.add("\t\tFLG_TCP_CEP_EST#{params[:vrid_tcp6_cepid].val + $cfgData[:TCP6_CRE_CEP].size},")
+			$tinetCfgC.add("\t\tFLG_TCP_CEP_SND#{params[:vrid_tcp6_cepid].val + $cfgData[:TCP6_CRE_CEP].size},")
+			$tinetCfgC.add("\t\tFLG_TCP_CEP_RCV#{params[:vrid_tcp6_cepid].val + $cfgData[:TCP6_CRE_CEP].size},")
 			$tinetCfgC.add("\t\t},")
 	end
@@ -288,7 +288,7 @@
 
 #	// UDP (IPv4) éä¿¡ç«¯ç¹
-if $cfgData[:UDP_CRE_CEP].size > 0 || $cfgData[:VRID_UDP_CEP].size > 0
-	$tinetCfgC.add()
-	$tinetCfgC.add("#define TNUM_UDP_CEPID	#{$cfgData[:UDP_CRE_CEP].size + $cfgData[:VRID_UDP_CEP].size}")
+if $cfgData[:UDP_CRE_CEP].size > 0 || $cfgData[:VRID_UDP4_CEP].size > 0
+	$tinetCfgC.add()
+	$tinetCfgC.add("#define TNUM_UDP_CEPID	#{$cfgData[:UDP_CRE_CEP].size + $cfgData[:VRID_UDP4_CEP].size}")
 	$tinetCfgC.add()
 	$tinetCfgC.add("const ID tmax_udp_cepid = (TMIN_UDP_CEPID + TNUM_UDP_CEPID - 1);")
@@ -307,5 +307,5 @@
 			$tinetCfgC.add("\t\t},")
 	end
-	$cfgData[:VRID_UDP_CEP].each do |key, params|
+	$cfgData[:VRID_UDP4_CEP].each do |key, params|
 		$tinetCfgC.add("\t{")
 			$tinetCfgC.add("\t\t0,")
@@ -313,8 +313,8 @@
 			$tinetCfgC.add("\t\t(t_udp_callback)(FP)NULL,")
 			$tinetCfgC.add("\t\tUDP_CEP_FLG_DYNAMIC,")
-			$tinetCfgC.add("\t\tSEM_UDP_CEP_LOCK#{params[:udp4_cepid].val + $cfgData[:UDP_CRE_CEP].size},")
-			$tinetCfgC.add("\t\tTA_NULL,")
-			$tinetCfgC.add("\t\tTA_NULL,")
-			$tinetCfgC.add("\t\tDTQ_UDP_RCVQ#{params[:udp4_cepid].val + $cfgData[:UDP_CRE_CEP].size},")
+			$tinetCfgC.add("\t\tSEM_UDP_CEP_LOCK#{params[:vrid_udp4_cepid].val + $cfgData[:UDP_CRE_CEP].size},")
+			$tinetCfgC.add("\t\tTA_NULL,")
+			$tinetCfgC.add("\t\tTA_NULL,")
+			$tinetCfgC.add("\t\tDTQ_UDP_RCVQ#{params[:vrid_udp4_cepid].val + $cfgData[:UDP_CRE_CEP].size},")
 			$tinetCfgC.add("\t\t},")
 	end
@@ -348,8 +348,8 @@
 			$tinetCfgC.add("\t\t(t_udp_callback)(FP)NULL,")
 			$tinetCfgC.add("\t\tUDP_CEP_FLG_DYNAMIC,")
-			$tinetCfgC.add("\t\tSEM_UDP_CEP_LOCK#{params[:udp6_cepid].val + $cfgData[:UDP6_CRE_CEP].size},")
-			$tinetCfgC.add("\t\tTA_NULL,")
-			$tinetCfgC.add("\t\tTA_NULL,")
-			$tinetCfgC.add("\t\tDTQ_UDP_RCVQ#{params[:udp6_cepid].val + $cfgData[:UDP6_CRE_CEP].size},")
+			$tinetCfgC.add("\t\tSEM_UDP_CEP_LOCK#{params[:vrid_udp6_cepid].val + $cfgData[:UDP6_CRE_CEP].size},")
+			$tinetCfgC.add("\t\tTA_NULL,")
+			$tinetCfgC.add("\t\tTA_NULL,")
+			$tinetCfgC.add("\t\tDTQ_UDP_RCVQ#{params[:vrid_udp6_cepid].val + $cfgData[:UDP6_CRE_CEP].size},")
 			$tinetCfgC.add("\t\t},")
 	end
@@ -362,5 +362,5 @@
 
 #	// TCP (IPv4) åä»å£
-if $cfgData[:TCP_CRE_REP].size > 0 || $cfgData[:VRID_TCP_REP].size > 0
+if $cfgData[:TCP_CRE_REP].size > 0 || $cfgData[:VRID_TCP4_REP].size > 0
 	$cfgData[:TCP_CRE_REP].each do |key, params|
 		cfgInfo = { APINAME: "CRE_SEM" }
@@ -371,7 +371,7 @@
 		$cfgFileInfo.push(cfgInfo)
 	end
-	$cfgData[:VRID_TCP_REP].each do |key, params|
-		cfgInfo = { APINAME: "CRE_SEM" }
-		cfgInfo["semid"] = "SEM_TCP_REP_LOCK#{params[:tcp4_repid].val + $cfgData[:TCP_CRE_REP].size}"
+	$cfgData[:VRID_TCP4_REP].each do |key, params|
+		cfgInfo = { APINAME: "CRE_SEM" }
+		cfgInfo["semid"] = "SEM_TCP_REP_LOCK#{params[:vrid_tcp4_repid].val + $cfgData[:TCP_CRE_REP].size}"
 		cfgInfo["sematr"] = NumStr.new($TA_TPRI, "TA_TPRI")
 		cfgInfo["isemcnt"] = 1
@@ -393,5 +393,5 @@
 	$cfgData[:VRID_TCP6_REP].each do |key, params|
 		cfgInfo = { APINAME: "CRE_SEM" }
-		cfgInfo["semid"] = "SEM_TCP_REP_LOCK#{params[:tcp6_repid].val + $cfgData[:TCP6_CRE_REP].size}"
+		cfgInfo["semid"] = "SEM_TCP_REP_LOCK#{params[:vrid_tcp6_repid].val + $cfgData[:TCP6_CRE_REP].size}"
 		cfgInfo["sematr"] = NumStr.new($TA_TPRI, "TA_TPRI")
 		cfgInfo["isemcnt"] = 1
@@ -402,5 +402,5 @@
 
 #	// TCP (IPv4) éä¿¡ç«¯ç¹
-if $cfgData[:TCP_CRE_CEP].size > 0 || $cfgData[:VRID_TCP_CEP].size > 0
+if $cfgData[:TCP_CRE_CEP].size > 0 || $cfgData[:VRID_TCP4_CEP].size > 0
 	$cfgData[:TCP_CRE_CEP].each do |key, params|
 		cfgInfo = { APINAME: "CRE_SEM" }
@@ -429,26 +429,26 @@
 		$cfgFileInfo.push(cfgInfo)
 	end
-	$cfgData[:VRID_TCP_CEP].each do |key, params|
-		cfgInfo = { APINAME: "CRE_SEM" }
-		cfgInfo["semid"] = "SEM_TCP_CEP_LOCK#{params[:tcp4_cepid].val + $cfgData[:TCP_CRE_CEP].size}"
-		cfgInfo["sematr"] = NumStr.new($TA_TPRI, "TA_TPRI")
-		cfgInfo["isemcnt"] = 1
-		cfgInfo["maxsem"] = 1
-		$cfgFileInfo.push(cfgInfo)
-
-		cfgInfo = { APINAME: "CRE_FLG" }
-		cfgInfo["flgid"] = "FLG_TCP_CEP_EST#{params[:tcp4_cepid].val + $cfgData[:TCP_CRE_CEP].size}"
-		cfgInfo["flgatr"] = NumStr.new($TA_TFIFO | $TA_WSGL, "TA_TFIFO|TA_WSGL")
-		cfgInfo["iflgptn"] = NumStr.new($TCP_CEP_EVT_CLOSED, "TCP_CEP_EVT_CLOSED")
-		$cfgFileInfo.push(cfgInfo)
-
-		cfgInfo = { APINAME: "CRE_FLG" }
-		cfgInfo["flgid"] = "FLG_TCP_CEP_SND#{params[:tcp4_cepid].val + $cfgData[:TCP_CRE_CEP].size}"
-		cfgInfo["flgatr"] = NumStr.new($TA_TFIFO | $TA_WSGL, "TA_TFIFO|TA_WSGL")
-		cfgInfo["iflgptn"] = NumStr.new($TCP_CEP_EVT_CLOSED, "TCP_CEP_EVT_CLOSED")
-		$cfgFileInfo.push(cfgInfo)
-
-		cfgInfo = { APINAME: "CRE_FLG" }
-		cfgInfo["flgid"] = "FLG_TCP_CEP_RCV#{params[:tcp4_cepid].val + $cfgData[:TCP_CRE_CEP].size}"
+	$cfgData[:VRID_TCP4_CEP].each do |key, params|
+		cfgInfo = { APINAME: "CRE_SEM" }
+		cfgInfo["semid"] = "SEM_TCP_CEP_LOCK#{params[:vrid_tcp4_cepid].val + $cfgData[:TCP_CRE_CEP].size}"
+		cfgInfo["sematr"] = NumStr.new($TA_TPRI, "TA_TPRI")
+		cfgInfo["isemcnt"] = 1
+		cfgInfo["maxsem"] = 1
+		$cfgFileInfo.push(cfgInfo)
+
+		cfgInfo = { APINAME: "CRE_FLG" }
+		cfgInfo["flgid"] = "FLG_TCP_CEP_EST#{params[:vrid_tcp4_cepid].val + $cfgData[:TCP_CRE_CEP].size}"
+		cfgInfo["flgatr"] = NumStr.new($TA_TFIFO | $TA_WSGL, "TA_TFIFO|TA_WSGL")
+		cfgInfo["iflgptn"] = NumStr.new($TCP_CEP_EVT_CLOSED, "TCP_CEP_EVT_CLOSED")
+		$cfgFileInfo.push(cfgInfo)
+
+		cfgInfo = { APINAME: "CRE_FLG" }
+		cfgInfo["flgid"] = "FLG_TCP_CEP_SND#{params[:vrid_tcp4_cepid].val + $cfgData[:TCP_CRE_CEP].size}"
+		cfgInfo["flgatr"] = NumStr.new($TA_TFIFO | $TA_WSGL, "TA_TFIFO|TA_WSGL")
+		cfgInfo["iflgptn"] = NumStr.new($TCP_CEP_EVT_CLOSED, "TCP_CEP_EVT_CLOSED")
+		$cfgFileInfo.push(cfgInfo)
+
+		cfgInfo = { APINAME: "CRE_FLG" }
+		cfgInfo["flgid"] = "FLG_TCP_CEP_RCV#{params[:vrid_tcp4_cepid].val + $cfgData[:TCP_CRE_CEP].size}"
 		cfgInfo["flgatr"] = NumStr.new($TA_TFIFO | $TA_WSGL, "TA_TFIFO|TA_WSGL")
 		cfgInfo["iflgptn"] = NumStr.new($TCP_CEP_EVT_CLOSED, "TCP_CEP_EVT_CLOSED")
@@ -487,24 +487,24 @@
 	$cfgData[:VRID_TCP6_CEP].each do |key, params|
 		cfgInfo = { APINAME: "CRE_SEM" }
-		cfgInfo["semid"] = "SEM_TCP_CEP_LOCK#{params[:tcp6_cepid].val + $cfgData[:TCP6_CRE_CEP].size}"
-		cfgInfo["sematr"] = NumStr.new($TA_TPRI, "TA_TPRI")
-		cfgInfo["isemcnt"] = 1
-		cfgInfo["maxsem"] = 1
-		$cfgFileInfo.push(cfgInfo)
-
-		cfgInfo = { APINAME: "CRE_FLG" }
-		cfgInfo["flgid"] = "FLG_TCP_CEP_EST#{params[:tcp6_cepid].val + $cfgData[:TCP6_CRE_CEP].size}"
-		cfgInfo["flgatr"] = NumStr.new($TA_TFIFO | $TA_WSGL, "TA_TFIFO|TA_WSGL")
-		cfgInfo["iflgptn"] = NumStr.new($TCP_CEP_EVT_CLOSED, "TCP_CEP_EVT_CLOSED")
-		$cfgFileInfo.push(cfgInfo)
-
-		cfgInfo = { APINAME: "CRE_FLG" }
-		cfgInfo["flgid"] = "FLG_TCP_CEP_SND#{params[:tcp6_cepid].val + $cfgData[:TCP6_CRE_CEP].size}"
-		cfgInfo["flgatr"] = NumStr.new($TA_TFIFO | $TA_WSGL, "TA_TFIFO|TA_WSGL")
-		cfgInfo["iflgptn"] = NumStr.new($TCP_CEP_EVT_CLOSED, "TCP_CEP_EVT_CLOSED")
-		$cfgFileInfo.push(cfgInfo)
-
-		cfgInfo = { APINAME: "CRE_FLG" }
-		cfgInfo["flgid"] = "FLG_TCP_CEP_RCV#{params[:tcp6_cepid].val + $cfgData[:TCP6_CRE_CEP].size}"
+		cfgInfo["semid"] = "SEM_TCP_CEP_LOCK#{params[:vrid_tcp6_cepid].val + $cfgData[:TCP6_CRE_CEP].size}"
+		cfgInfo["sematr"] = NumStr.new($TA_TPRI, "TA_TPRI")
+		cfgInfo["isemcnt"] = 1
+		cfgInfo["maxsem"] = 1
+		$cfgFileInfo.push(cfgInfo)
+
+		cfgInfo = { APINAME: "CRE_FLG" }
+		cfgInfo["flgid"] = "FLG_TCP_CEP_EST#{params[:vrid_tcp6_cepid].val + $cfgData[:TCP6_CRE_CEP].size}"
+		cfgInfo["flgatr"] = NumStr.new($TA_TFIFO | $TA_WSGL, "TA_TFIFO|TA_WSGL")
+		cfgInfo["iflgptn"] = NumStr.new($TCP_CEP_EVT_CLOSED, "TCP_CEP_EVT_CLOSED")
+		$cfgFileInfo.push(cfgInfo)
+
+		cfgInfo = { APINAME: "CRE_FLG" }
+		cfgInfo["flgid"] = "FLG_TCP_CEP_SND#{params[:vrid_tcp6_cepid].val + $cfgData[:TCP6_CRE_CEP].size}"
+		cfgInfo["flgatr"] = NumStr.new($TA_TFIFO | $TA_WSGL, "TA_TFIFO|TA_WSGL")
+		cfgInfo["iflgptn"] = NumStr.new($TCP_CEP_EVT_CLOSED, "TCP_CEP_EVT_CLOSED")
+		$cfgFileInfo.push(cfgInfo)
+
+		cfgInfo = { APINAME: "CRE_FLG" }
+		cfgInfo["flgid"] = "FLG_TCP_CEP_RCV#{params[:vrid_tcp6_cepid].val + $cfgData[:TCP6_CRE_CEP].size}"
 		cfgInfo["flgatr"] = NumStr.new($TA_TFIFO | $TA_WSGL, "TA_TFIFO|TA_WSGL")
 		cfgInfo["iflgptn"] = NumStr.new($TCP_CEP_EVT_CLOSED, "TCP_CEP_EVT_CLOSED")
@@ -514,5 +514,5 @@
 
 #	// UDP (IPv4) éä¿¡ç«¯ç¹
-if $cfgData[:UDP_CRE_CEP].size > 0 || $cfgData[:VRID_UDP_CEP].size > 0
+if $cfgData[:UDP_CRE_CEP].size > 0 || $cfgData[:VRID_UDP4_CEP].size > 0
 	$cfgData[:UDP_CRE_CEP].each do |key, params|
 		cfgInfo = { APINAME: "CRE_SEM" }
@@ -530,7 +530,7 @@
 		$cfgFileInfo.push(cfgInfo)
 	end
-	$cfgData[:VRID_UDP_CEP].each do |key, params|
-		cfgInfo = { APINAME: "CRE_SEM" }
-		cfgInfo["semid"] = "SEM_UDP_CEP_LOCK#{params[:udp4_cepid].val + $cfgData[:UDP_CRE_CEP].size}"
+	$cfgData[:VRID_UDP4_CEP].each do |key, params|
+		cfgInfo = { APINAME: "CRE_SEM" }
+		cfgInfo["semid"] = "SEM_UDP_CEP_LOCK#{params[:vrid_udp4_cepid].val + $cfgData[:UDP_CRE_CEP].size}"
 		cfgInfo["sematr"] = NumStr.new($TA_TPRI, "TA_TPRI")
 		cfgInfo["isemcnt"] = 1
@@ -539,5 +539,5 @@
 
 		cfgInfo = { APINAME: "CRE_DTQ" }
-		cfgInfo["dtqid"] = "DTQ_UDP_RCVQ#{params[:udp4_cepid].val + $cfgData[:UDP_CRE_CEP].size}"
+		cfgInfo["dtqid"] = "DTQ_UDP_RCVQ#{params[:vrid_udp4_cepid].val + $cfgData[:UDP_CRE_CEP].size}"
 		cfgInfo["dtqatr"] = NumStr.new($TA_TFIFO, "TA_TFIFO")
 		cfgInfo["dtqcnt"] = NumStr.new($NUM_DTQ_UDP_RCVQ, "NUM_DTQ_UDP_RCVQ")
@@ -566,5 +566,5 @@
 	$cfgData[:VRID_UDP6_CEP].each do |key, params|
 		cfgInfo = { APINAME: "CRE_SEM" }
-		cfgInfo["semid"] = "SEM_UDP_CEP_LOCK#{params[:udp6_cepid].val + $cfgData[:UDP6_CRE_CEP].size}"
+		cfgInfo["semid"] = "SEM_UDP_CEP_LOCK#{params[:vrid_udp6_cepid].val + $cfgData[:UDP6_CRE_CEP].size}"
 		cfgInfo["sematr"] = NumStr.new($TA_TPRI, "TA_TPRI")
 		cfgInfo["isemcnt"] = 1
@@ -573,5 +573,5 @@
 
 		cfgInfo = { APINAME: "CRE_DTQ" }
-		cfgInfo["dtqid"] = "DTQ_UDP_RCVQ#{params[:udp6_cepid].val + $cfgData[:UDP6_CRE_CEP].size}"
+		cfgInfo["dtqid"] = "DTQ_UDP_RCVQ#{params[:vrid_udp6_cepid].val + $cfgData[:UDP6_CRE_CEP].size}"
 		cfgInfo["dtqatr"] = NumStr.new($TA_TFIFO, "TA_TFIFO")
 		cfgInfo["dtqcnt"] = NumStr.new($NUM_DTQ_UDP_RCVQ, "NUM_DTQ_UDP_RCVQ")